package asd.td5;

import asd.arbre.ArbreBinaire;

/**
 * Une classe pour l'exercice 4 de la feuille 5.
 * @author  2002 Marc Gatano
 */
public class Isomorphisme {

    /**
     * Teste si les deux arbres A et B sont quivalents
     * Complexit : O(n) o n = taille(A) = taille(B)
     */
    public static boolean equivalent(ArbreBinaire A, ArbreBinaire B) {
        if ( A.vide() ) {
            return B.vide();
        }
        if ( B.vide() ) {
            return false;
        }
        return equivalent(A.gauche(),B.gauche()) &&
               equivalent(A.droite(),B.droite());
    }

    /**
     * Teste si les deux arbres A et B sont isomorphes
     * Complexit : O(n^k) avec n = taille(A) = taille(B) et
     * k = 1/log[3](2) (~ 1,58)
     */
    public static boolean isomorphe(ArbreBinaire A, ArbreBinaire B) {
        if ( A.vide() ) {
            return B.vide();
        }
        if ( B.vide() ) {
            return false;
        }
        if ( isomorphe(A.gauche(),B.gauche()) ) {
            return isomorphe(A.droite(),B.droite());
        }
        return isomorphe(A.gauche(),B.droite()) &&
               isomorphe(A.droite(),B.gauche());
    }
}
